<script lang="ts">
  import { FormGroup, Input, Label, Table } from '@sveltestrap/sveltestrap';
  import type { ActiveChallenge, ChallengeFile } from '@models/Challenges';
  import { postFiles } from '@utils/FileStorageApi.js';
  import type { NullableEventRole } from '@auth/models';
  import { InsertChallengeFile } from '@queries/Challenges.Files';
  import Fa from 'svelte-fa';
  import { faTrashCan } from '@fortawesome/free-solid-svg-icons';

  export let activeChallenge: ActiveChallenge;
  export let deleteAtleastOne: (table: string, where: string) => Promise<boolean>;
  export let queryRole: NullableEventRole;
  let pendingFiles: FileList | null = null;
  let feedback: string | null = null;
  let uploading: boolean = false;

  async function uploadFiles() {
    feedback = null;
    uploading = true;
    pendingFiles = document.getElementById('fileInput').files;

    if (!pendingFiles?.length) return; // disabled if no pending files available

    console.log(pendingFiles);
    let response;
    // upload files
    try {
      response = await postFiles(pendingFiles);
      console.log(response);
    } catch (err) {
      if (err.message?.includes('status code 413')) {
        feedback = 'A file was too Large';
      } else {
        feedback = err.message || err;
      }
      console.error(err);
    }

    for (const file of response.data.processedFiles) {
      // create challenges.files
      const response = await InsertChallengeFile(
        {
          challenge_id: activeChallenge.challenge_id,
          event_id: activeChallenge.event_id,
          file_id: file.id,
        },
        { role: queryRole },
      );
      // Add to results array
      // update Active Challenge
      activeChallenge.files?.push(response.insert_challenges_files_one);
    }

    // trigger reload
    activeChallenge = activeChallenge;
    // reset file upload
    pendingFiles = null;
    uploading = false;
  }

  async function deleteFile(e: Event, file: ChallengeFile): Promise<boolean> {
    e.preventDefault();
    e.stopPropagation();
    let success;
    // todo need to delete from storage.files and actual file in bucket?
    success = await deleteAtleastOne(
      'delete_challenges_files',
      `{
          challenge_id: {_eq: ${JSON.stringify(activeChallenge.challenge_id)}}
          event_id: {_eq: ${JSON.stringify(file.event_id)}}
          file_id: {_eq: ${JSON.stringify(file.file_id)}}
         }`,
    );
    if (!success) console.error(`No rows affected when deleting flag '${file.file_id}'`);
    if (success) activeChallenge.files = activeChallenge.files?.filter((f) => f.file_id !== file.file_id);
  }
</script>

<FormGroup>
  <Label class="hstack">
    <span class="fs-3 me-5">Files</span>
    <Input multiple type="file" id="fileInput" on:change={uploadFiles} />
  </Label>
  {#if uploading}
    <div class="container text-center">
      <div class="spinner-border text-primary" role="status">
        <span class="sr-only">Uploading...</span>
      </div>
    </div>
  {/if}

  {#if activeChallenge.files.length > 0}
    <Table>
      <thead>
        <th class="py-1 px-2">Size</th>
        <th class="py-1 px-2">Name</th>
        <th class="py-1 px-2">Last Updated</th>
        <th />
      </thead>
      <tbody>
        {#each activeChallenge.files as file (file.file_id)}
          <tr>
            <td>{file.file.size}</td>
            <td>{file.file.name}</td>
            <td>{file.file.updatedAt}</td>
            <td>
              <span on:click={(e) => deleteFile(e, file, activeChallenge)} class="text-danger clickable">
                <Fa icon={faTrashCan} />
              </span>
            </td>
          </tr>
        {/each}
      </tbody>
    </Table>
  {/if}
</FormGroup>
